local _, ns = ...
if not ns.L then ns.L = { } end

local L = setmetatable(ns.L, { __index = function(t, k)
	if not k then return "" end
	local v = tostring(k)
	t[k] = v
	return v
end })

--[[ Tracked buffs/spells go in here like this:

Buff that can be cast to anyone:
	[spellID] = {msg = L["Short description of actions in english] },
	
Class specific buff that can be only cast on yourself:
	[spellID] = {msg = L["Short description of actions in english], class = "CLASS_IN_CAPS" },

Global buff that can be on with multiple targets at the same time:
	[spellID] = {msg = L["Short description of actions in english], multi = true},

Spell that needs to be targeted:
	[spellID] = {},
	
Spell that doesn't need target:
	[spellID] = {notarget = true},

]]

OhSnap = {}
OhSnap.spells = {}
-- Debuffs tracked
OhSnap.spells[4] = {
	-- Paladin
		[25771] = {msg = L["Can't use Divine Shield"]},								-- Forbearance
	-- Mage
		[41425] = {msg = L["Can't use Ice Block"]},									-- Hypothermia
	-- Priest
		[6788] = {msg = L["Can't have Power Word: Shield"]},						-- Weakened Soul
	-- Shaman
		[57723] = {msg = L["Can't use Heroism"], multi = true},						-- Exhaustion
		[57724] = {msg = L["Can't use Bloodlust"], multi = true},					-- Sated
	-- Misc
		[9484] = {msg = L["CC, Do not damage!"]}, 									-- Shackle Undead
		[605] = {msg = L["Mind Controlled!"]},										-- Mind Control	
		[6358] = {msg = L["CC, Do not damage!"]},									-- Seduction
		[1098] = {msg = L["CC, Do not damage!"]},									-- Enslave Demon
		[710] = {msg = L["Banished, Immune"]},										-- Banish
		[118699] = {msg = L["CC, Do not damage!"]},									-- Fear	
		[6789] = {msg = L["CC, Do not damage!"]},									-- Mortal Coil
		[115268] = {msg = L["CC, Do not damage!"]},									-- Mesmerize
		[118] = {msg = L["CC, Do not damage!"]},									-- Polymorph
		--[28271] = {msg = L["CC, Do not damage!"]},									-- Polymorph: Turtle
		--[28272] = {msg = L["CC, Do not damage!"]},									-- Polymorph: Pig
		--[61305] = {msg = L["CC, Do not damage!"]},									-- Polymorph: Black Cat
		--[61025] = {msg = L["CC, Do not damage!"]},									-- Polymorph: Serpent
		--[61721] = {msg = L["CC, Do not damage!"]},									-- Polymorph: Rabbit
		--[61780] = {msg = L["CC, Do not damage!"]},									-- Polymorph: Turkey
		[2637] = {msg = L["CC, Do not damage!"]},									-- Hibernate 
		[339] = {msg = L["CC, Do not damage!"]},									-- Entangling Roots
		[33786] = {msg = L["Cycloned, Immune"]},									-- Cyclone	
		[3355] = {msg = L["CC, Do not damage!"]},									-- Freezing Trap
		[19386] = {msg = L["CC, Do not damage!"]},									-- Wyvern Sting
		[1513] = {msg = L["CC, Do not damage!"]},									-- Scare Beast	
		[6770] = {msg = L["CC, Do not damage!"]},									-- Sap
		[2094] = {msg = L["CC, Do not damage!"]},									-- Blind	
		[20066] = {msg = L["CC, Do not damage!"]},									-- Repentance
		[10326] = {msg = L["CC, Do not damage!"]},									-- Turn Evil
		[853] = {msg = L["CC, Do not damage!"]},									-- Hammer of Justice	
		[51514] = {msg = L["CC, Do not damage!"]},									-- Hex
		[76780] = {msg = L["CC, Do not damage!"]},									-- Bind Elemental
	
}
-- Buffs tracked
OhSnap.spells[3] = {
	-- Druid
		[1850] = {msg = L["+Speed"], class = "DRUID"},								-- Dash
		[110570] = {msg = L["DoT Immune"], class = "DRUID"},						-- Symbiosis: Anti-Magic Shell
		[110617] = {msg = L["100% Parry, 100% Deflect"], class = "DRUID"}, 			-- Symbiosis: Deterrence
		[110715] = {msg = L["-90% damage"], class = "DRUID"},						-- Symbiosis: Dispersion
		[110717] = {msg = L["Fear Immune"]},										-- Symbiosis: Fear Ward
		[110788] = {msg = L["Spell Immune"], class = "DRUID"},						-- Symbiosis: Cloak of Shadows
		[110791] = {msg = L["+50% Dodge, -25% Ranged"], class = "DRUID"},			-- Symbiosis: Evasion
		[122291] = {msg = L["Uninterruptable"], class = "DRUID"},					-- Symbiosis: Unending Resolve
	-- Death Knight
		[42650] = {msg = L["Braiiiins!"], class = "DEATHKNIGHT"}, 					-- Army of the Dead
		[48707] = {msg = L["DoT Immune"], class = "DEATHKNIGHT"}, 					-- Anti-Magic Shell
		[49039] = {msg = L["Fear Immune, Shackleable"], class = "DEATHKNIGHT"}, 	-- Lichborne
		[51271] = {msg = L["Knockback Immune"], class = "DEATHKNIGHT"}, 			-- Pillar of Frost
		[48792] = {msg = L["Stun Immune"], class = "DEATHKNIGHT"},					-- Icebound Fortitude
		[108201] = {msg = L["CC Immune"], class = "DEATHKNIGHT"},					-- Desecrated Ground
	-- Hunter
		[19263] = {msg = L["100% Parry, 100% Deflect"], class = "HUNTER"},			-- Deterrence
		[13159] = {msg = L["Damage dazes"]},										-- Aspect of the Pack
		[113073] = {msg = L["+Speed"], class = "Hunter"},							-- Symbiosis: Dash
	-- Mage
		[12051] = {msg = L["Gaining mana"], class = "MAGE"},						-- Evocation
		[108839] = {msg = L["Can move while casting"], class = "MAGE"},				-- Ice Floes
		[115610] = {msg = L["Damage heals over time"], class = "MAGE"},				-- Temporal Sield
		[108843] = {msg = L["+Speed"], class = "MAGE"},								-- Blazing Speed
		[12043] = {msg = L["|cFFFF0000Instant cast|r"], class = "MAGE"},			-- Presence of Mind
	-- Monk
		[115176] = {msg = L["-90% damage, Melee hit cancels"], class = "MONK"},		-- Zen Meditation
		[115295] = {msg = L["|cFFFF0000Absorbs damage"], class = "MONK"},			-- Guard
		[116849] = {msg = L["|cFFFF0000Absorbs damage"]},							-- Life Cocoon
	-- Paladin
		[1044] = {msg = L["Snare Immune"]},											-- Hand of Freedom
		[31821] = {msg = L["Silence Immune"]},										-- Aura Mastery
		[85499] = {msg = L["+Speed"], class = "PALADIN"},							-- Speed of Light
	-- Priest
		[6346] = {msg = L["Fear Immune"]},											-- Fear Ward
		[47585] = {msg = L["-90% damage"], class = "PRIEST"},						-- Dispersion
	-- Rogue
		--[51690] = {msg = L["AoE, +20% Haste"], class = "ROGUE"},					-- Killing Spree
		[5277] = {msg = L["+50% Dodge, -25% Ranged"], class = "ROGUE"},				-- Evasion
		[2983] = {msg = L["+Speed"], class = "ROGUE"},								-- Sprint
		[31224] = {msg = L["Spell Immune"], class = "ROGUE"},						-- Cloak of Shadows
		[108212] = {msg = L["+Speed, Unstoppable"], class = "ROGUE"},				-- Burst of Speed
	-- Shaman
		[8178] = {msg = L["Grounding Totem"], multi = true},						-- Grounding Totem Effect
		[2825] = {msg = L["30% Haste"], multi = true},								-- Bloodlust
		[32182] = {msg = L["30% Haste"], multi = true},								-- Heroism
	-- Warrior
		[1719] = {msg = L["100% Crit"], class = "WARRIOR"},							-- Recklessness
		[18499] = {msg = L["CC Immune"], class = "WARRIOR"},						-- Berserker Rage
		[132404] = {msg = L["100% Melee Immune"], class = "WARRIOR"},				-- Shield Block
		[118038] = {msg = L["100% Parry"], class = "WARRIOR"},						-- Die by the Sword
	-- Warlock
		[20707] = {msg = L["Can Resurrect"]},										-- Soulstone
		[104773] = {msg = L["Uninterruptable"], class = "WARLOCK"},					-- Unending Resolve

	-- Misc
		[2479] = {msg = L["Do it."]},												-- Honorless Target
		[46705] = {msg = L["Do it."]},												-- Honorless Target
}
-- Dangerous Spells tracked
OhSnap.spells[2] = {
	-- Death Knight
		[108200] = {msg = L["Move Away"], class = "DEATHKNIGHT"},					-- Remorseless Winter
	-- Druid
		[16689] = {msg = L["|cFFFF0000Hit roots you|r"], class = "DRUID"},			-- Nature's Grasp
		[110696] = {msg = L["|cFFFF0000Immune|r, Dispellable"], class = "DRUID"},	-- Symbiosis: Ice Block
		[110700] = {msg = L["|cFFFF0000Immune|r, Dispellable"], class = "DRUID"},	-- Symbiosis: Divine Shield
		[113002] = {msg = L["|cFFFF0000No spells!|r"], class = "DRUID"},			-- Symbiosis: Spell Reflection
	-- Hunter
		[19574] = {msg = L["Unstoppable"]},											-- Bestial Wrath
	-- Mage
		[66] = {msg = L["|cFFFF0000Disappearing|r"], class = "MAGE"},				-- Invisibility
		[45438] = {msg = L["|cFFFF0000Immune|r, Dispellable"], class = "MAGE"},		-- Ice Block
	-- Monk
		[124280] = {msg = L["|cFFFF0000Damage redirected"], class = "MONK"},		-- Touch of Karma
		[113275] = {msg = L["|cFFFF0000Hit roots you|r"], class = "MONK"},			-- Symbiosis: Entangling Roots
	-- Paladin
		[642] = {msg = L["|cFFFF0000Immune|r, Dispellable"], class = "PALADIN"},	-- Divine Shield
		[1022] = {msg = L["Melee Immune, pacified"]},								-- Hand of Protection
	-- Priest
		[47788] = {msg = L["|cFFFF0000Unkillable|r"], class = "PRIEST"},			-- Guardian Spirit
	-- Warlock
		[110913] = {msg = L["Immune"], class = "WARLOCK"},							-- Dark Bargain
	-- Warrior
		[23920] = {msg = L["|cFFFF0000No spells!|r"], class = "WARRIOR"},			-- Spell Reflection
		[46924] = {msg = L["Move Away"], class = "WARRIOR"},						-- Bladestorm
		[114028] = {msg = L["|cFFFF0000No spells!|r"]},								-- Mass Spell Reflection
	-- Misc
		[43706] = {msg = L["|cFFFF0000Resting|r"]},									-- Drink
		
	-- TEST SPELLS
		[61574] = {msg = L["|cFF00AEEFFor Gnomeregan!|r"]},							-- Banner of the Horde
		[61573] = {msg = L["|cFFFF0000For the Horde!|r"]},							-- Banner of the Alliance
}
-- Spells tracked
OhSnap.spells[1] = {
	-- Druid
		[2637] = {},																-- Hibernate
		[33786] = {},																-- Cyclone
		[50769] = {},																-- Revive
		[339] = {},																	-- Entangling Roots
		[20484] = {},																-- Rebirth
		[110309] = {},																-- Symbiosis
	-- Hunter
		[982] = {notarget = true},													-- Revive Pet
		[1513] = {},																-- Scare Beast
	-- Mage
		[118] = {},																	-- Polymorph
		[28271] = {},																-- Polymorph: Turtle
		[28272] = {},																-- Polymorph: Pig
		[61025] = {},																-- Polymorph: Serpent
		[61305] = {},																-- Polymorph: Black Cat
		[61721] = {},																-- Polymorph: Rabbit
		[61780] = {},																-- Polymorph: Turkey
		[82691] = {},																-- Ring of Frost
		[102051] = {},																-- Frostjaw
	-- Monk
		[115178] = {},																-- Resuscitate
	-- Paladin
		[7328] = {},																-- Redemption
		[20066] = {},																-- Repentance
		[113269] = {},																-- Symbiosis: Rebirth
	-- Priest
		[605] = {},																	-- Dominate Mind
		[8129] = {},																-- Mana Burn
		[2006] = {},																-- Resurrection
		[9484] = {},																-- Shackle Undead
		[113506] = {},																-- Symbiosis: Cyclone
	-- Shaman
		[2008] = {},																-- Ancestral Spirit
		[51514] = {},																-- Hex
	-- Warlock
		[688] = {notarget = true},													-- Summon Imp
		[691] = {notarget = true},													-- Summon Felhunter
		[697] = {notarget = true},													-- Summon Voidwalker
		[712] = {notarget = true},													-- Summon Succubus
		[36226] = {notarget = true},												-- Summon Fel Imp
		[112867] = {notarget = true},												-- Summon Voidlord
		[112868] = {notarget = true},												-- Summon Shivarra
		[112869] = {notarget = true},												-- Summon Observer
		[5782] = {},																-- Fear
		[710] = {},																	-- Banish
		[30146] = {notarget = true},												-- Summon Felguard
		[20707] = {},																-- Soulstone
	-- Warrior
		[64382] = {},																-- Shattering Throw
}